/*
    bdel (Blacky's Del 100%)

    Dieses Programm sorgt dafr das Dateien WIRKLICH gelscht werden.
    Es berschreibt die Dateien bevor es sie Lscht.

    Copyright (C) Andreas Hofmeier

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
	      hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/


*/


#include <stdio.h>
#include <string.h>
#include "hofmeier.h"


char blacky_ver_info[] = "Blacky Del 100pro v0.04 (c) Copyright 1998,2003 Andreas Hofmeier";


main(argc, argv)
  int argc;
  char *argv[];
{
  FILE *f;
  int i;
  long l;
  char *c, sab[20];

  int BUFSIZE = 1024;
  char buf[BUFSIZE];

  allblackyintro(blacky_ver_info);

  if (argc == 1 || ((argc > 1) ? ((argv[1][0] == '-') && ((argv[1][1] == '?') || (toupper(argv[1][1]) == 'H'))) : 0))
    {
      printf("Help:\n");
      printf("  bdel <file to del 100%> [-v]\n");
      printf("    -v: Version, Licenze\n");
      exit(0);
    }

  if ((argc == 2) ? ((argv[1][0] == '-') && (toupper(argv[1][1]) == 'V')) : 0) {
    printf("%s\n\n", blacky_ver_info);
    printkinfo(stdout);
    exit(0);
  }

  /* Sicherheitzabfrage */
  printf("%c***** WARNING *****\n", 7);
  for (i = 1; i <= (argc - 1); i++) {
    printf("%s  ", argv[i]);
  }
  printf("\nDo you want OVERWRITE this files?\n");
  printf("(Yes/No): ");
  gets(sab);
  if ((toupper(sab[0]) != 'Y') && (toupper(sab[0]) != 'J')) {
    return;
  }

  memset(buf, '*', BUFSIZE);

  /* Lschen */
  for (i = 1; i <= (argc - 1); i++) {
    if ((l = filelen(argv[i])) > 0) {
      if ((f = fopen(argv[i], "r+")) == NULL) {
	perror(argv[i]);
	//	printf("removing file %s...\n", argv[i]);
	//	remove(argv[i]);
      } else {
	printf("overwritting file %s...\n", argv[i]);
	for (  ;  l > 0; l -= BUFSIZE) {
	  fwrite(buf, BUFSIZE, 1, f);
	}
	ffsync(f);
	fclose(f);
	if (remove(argv[i]) != 0) {
	  perror(argv[i]);
	}
      }
    } else {
      printf("removing file %s...\n", argv[i]);
      if (remove(argv[i]) != 0) {
	perror(argv[i]);
      }
    }
  }
  sync();
}
